Unit SF11R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF10_p;

function SF11R(X :Real; L :Integer; var IERR :Integer): Real;

implementation

function SF11R(X :Real; L :Integer; var IERR :Integer): Real;
var
I :Integer;
A,XX,SUMP,SUMQ,SUMF,SUMG :Real;
P :Array [0..4] of Real;
Q :Array [0..3] of Real;
F :Array [0..4] of Real;
G :Array [0..1] of Real;
PP :Array [0..9] of Real;
QQ :Array [0..7] of Real;
const
ONE :Real = 1.0E0;
ZERO :Real = 0.0E0;
SYS059 :Real = 3.4E38;
SYS061 :Real = 1.2E-38;
XMAX :Real = 44.36;
SYS073 :Real = 3.743392E-23;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12;
begin
{ Result -    SF11R  FORTRANe }
{   DATA  FORTRAN  }
P[0] := 1.203177E-01;
P[1] := 2.499784E01;
P[2] := 1.797135E03;
P[3] := 4.433331E04;
P[4] := 1.798473E05;
Q[0] := 2.500000E-01;
Q[1] := -7.035979E01;
Q[2] := 9.316075E03;
Q[3] := -5.537344E05;
F[0] := 2.107619E-03;
F[1] := 4.076347E-01;
F[2] := 3.092138E01;
F[3] := 9.517919E02;
F[4] := 8.501049E03;
G[0] := -2.216787E02;
G[1] := 1.700210E04;
PP[0] := 6.982646E-02;
PP[1] := 6.943429E00;
PP[2] := 1.016245E02;
PP[3] := 5.190226E02;
PP[4] := 1.207120E03;
PP[5] := 1.430398E03;
PP[6] := 9.005826E02;
PP[7] := 2.986452E02;
PP[8] := 4.833008E01;
PP[9] := 2.958172E00;
QQ[0] := 3.017104E01;
QQ[1] := 2.281150E02;
QQ[2] := 6.730124E02;
QQ[3] := 9.246058E02;
QQ[4] := 6.385721E02;
QQ[5] := 2.244323E02;
QQ[6] := 3.767672E01;
QQ[7] := 2.360280E00;
IERR := 0;
if ( X < SYS061 ) 
 then goto _8;
A := ONE;
if ( L <> 1 ) and ( L <> 2 ) 
 then goto _10;
case L of
 1: goto _1;
 2: goto _2;
end;
_1:
if ( X > XMAX ) 
 then goto _9;
if ( X <= ONE ) 
 then goto _3;
A := Exp(-X);
goto _5;
_2:
if ( X > ONE ) 
 then goto _5;
A := Exp(X);
_3:
if ( X < SYS073 ) 
 then goto _4;
XX := X*X;
SUMP := ((((P[0]*XX+P[1])*XX+P[2])*XX+P[3])*XX+P[4])*XX+
    Q[3];
SUMQ := ((Q[0]*XX+Q[1])*XX+Q[2])*XX+Q[3];
SUMF := (((F[0]*XX+F[1])*XX+F[2])*XX+F[3])*XX+F[4];
SUMG := (XX+G[0])*XX+G[1];
Result := ((XX*Ln(X)*SUMF/SUMG+SUMP/SUMQ)/X)*A;
goto _12;
_4:
Result := ONE/X;
goto _12;
_5:
XX := ONE/X;
SUMP := PP[0];
for I:=2 to 10 do
 begin
  SUMP := SUMP*XX+PP[I-1];
_6:
 end;
SUMQ := XX;
for I:=1 to 7 do
 begin
  SUMQ := (SUMQ+QQ[I-1])*XX;
_7:
 end;
SUMQ := SUMQ+QQ[7];
Result := A*SUMP/SUMQ/Sqrt(X);
goto _12;
_8:
IERR := 66;
Result := SYS059;
goto _11;
_9:
IERR := 67;
Result := ZERO;
goto _11;
_10:
Result := SYS059;
IERR := 65;
_11:
UTSF10(IERR,11);
_12:
exit;
end;

end.
